//------------------------------------------------------------------------------
// <auto-generated>
//     This code was generated by a tool.
//     Runtime Version:4.0.30319.42000
//
//     Changes to this file may cause incorrect behavior and will be lost if
//     the code is regenerated.
// </auto-generated>
//------------------------------------------------------------------------------

using System.Linq;
using Tecan.Sila2;
using Tecan.Sila2.Client;
using Tecan.Sila2.Server;

namespace Tecan.Sila2.Authentication
{
    
    
    /// <summary>
    /// A class that exposes the IAuthenticationService interface via SiLA2
    /// </summary>
    [System.ComponentModel.Composition.ExportAttribute(typeof(IFeatureProvider))]
    [System.ComponentModel.Composition.PartCreationPolicyAttribute(System.ComponentModel.Composition.CreationPolicy.Shared)]
    public partial class AuthenticationServiceProvider : IFeatureProvider
    {
        
        private IAuthenticationService _implementation;
        
        private Tecan.Sila2.Server.ISiLAServer _server;
        
        private static Tecan.Sila2.Feature _feature = FeatureSerializer.LoadFromAssembly(typeof(AuthenticationServiceProvider).Assembly, "AuthenticationService.sila.xml");
        
        /// <summary>
        /// Creates a new instance
        /// </summary>
        /// <param name="implementation">The implementation to exported through SiLA2</param>
        /// <param name="server">The SiLA2 server instance through which the implementation shall be exported</param>
        [System.ComponentModel.Composition.ImportingConstructorAttribute()]
        public AuthenticationServiceProvider(IAuthenticationService implementation, Tecan.Sila2.Server.ISiLAServer server)
        {
            _implementation = implementation;
            _server = server;
        }
        
        /// <summary>
        /// The feature that is exposed by this feature provider
        /// </summary>
        /// <returns>A feature object</returns>
        public Tecan.Sila2.Feature FeatureDefinition
        {
            get
            {
                return _feature;
            }
        }
        
        /// <summary>
        /// Registers the feature in the provided feature registration
        /// </summary>
        /// <param name="registration">The registration component to which the feature should be registered</param>
        public void Register(IServerBuilder registration)
        {
            registration.RegisterUnobservableCommand<LoginRequestDto, LoginResponseDto>("Login", Login);
            registration.RegisterUnobservableCommand<LogoutRequestDto, EmptyRequest>("Logout", Logout);
        }
        
        /// <summary>
        /// Executes the Login command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual LoginResponseDto Login(LoginRequestDto request)
        {
            try
            {
                request.Validate();
                return new LoginResponseDto(_implementation.Login(request.UserIdentification.TryExtract(_server, "org.silastandard/core/AuthenticationService/v1/Command/Login/Parameter/UserIdenti" +
                                "fication"), request.Password.TryExtract(_server, "org.silastandard/core/AuthenticationService/v1/Command/Login/Parameter/Password"), request.RequestedServer.TryExtract(_server, "org.silastandard/core/AuthenticationService/v1/Command/Login/Parameter/RequestedS" +
                                "erver"), request.RequestedFeatures.TryExtract(_server, "org.silastandard/core/AuthenticationService/v1/Command/Login/Parameter/RequestedF" +
                                "eatures")), _server);
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "userIdentification"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/AuthenticationService/v1/Command/Login/Parameter/UserIdenti" +
                            "fication", ex.Message);
                }
                if ((ex.ParamName == "password"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/AuthenticationService/v1/Command/Login/Parameter/Password", ex.Message);
                }
                if ((ex.ParamName == "requestedServer"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/AuthenticationService/v1/Command/Login/Parameter/RequestedS" +
                            "erver", ex.Message);
                }
                if ((ex.ParamName == "requestedFeatures"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/AuthenticationService/v1/Command/Login/Parameter/RequestedF" +
                            "eatures", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            } catch (AuthenticationFailedException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/core/AuthenticationService/v1/DefinedExecutionError/Authenticati" +
                        "onFailed", "The provided credentials are not valid.", ex.Message);
            }
        }
        
        /// <summary>
        /// Executes the Logout command
        /// </summary>
        /// <param name="request">A data transfer object that contains the command parameters</param>
        /// <returns>The command response wrapped in a data transfer object</returns>
        protected virtual EmptyRequest Logout(LogoutRequestDto request)
        {
            try
            {
                request.Validate();
                _implementation.Logout(request.AccessToken.TryExtract(_server, "org.silastandard/core/AuthenticationService/v1/Command/Logout/Parameter/AccessTok" +
                            "en"));
                return EmptyRequest.Instance;
            } catch (System.ArgumentException ex)
            {
                if ((ex.ParamName == "accessToken"))
                {
                    throw _server.ErrorHandling.CreateValidationError("org.silastandard/core/AuthenticationService/v1/Command/Logout/Parameter/AccessTok" +
                            "en", ex.Message);
                }
                throw _server.ErrorHandling.CreateUnknownValidationError(ex);
            } catch (InvalidAccessTokenException ex)
            {
                throw _server.ErrorHandling.CreateExecutionError("org.silastandard/core/AuthenticationService/v1/DefinedExecutionError/InvalidAcces" +
                        "sToken", "The sent access token is not valid.", ex.Message);
            }
        }
        
        /// <summary>
        /// Gets the command with the given identifier
        /// </summary>
        /// <param name="commandIdentifier">A fully qualified command identifier</param>
        /// <returns>A method object or null, if the command is not supported</returns>
        public System.Reflection.MethodInfo GetCommand(string commandIdentifier)
        {
            if ((commandIdentifier == "org.silastandard/core/AuthenticationService/v1/Command/Login"))
            {
                return typeof(IAuthenticationService).GetMethod("Login");
            }
            if ((commandIdentifier == "org.silastandard/core/AuthenticationService/v1/Command/Logout"))
            {
                return typeof(IAuthenticationService).GetMethod("Logout");
            }
            return null;
        }
        
        /// <summary>
        /// Gets the property with the given identifier
        /// </summary>
        /// <param name="propertyIdentifier">A fully qualified property identifier</param>
        /// <returns>A property object or null, if the property is not supported</returns>
        public System.Reflection.PropertyInfo GetProperty(string propertyIdentifier)
        {
            return null;
        }
    }
}

